#include <stdafx.h>
#include <windows.h>
#include "autolpt.h"
#include "extprg.h"
#include "letstack.h"
#include "letstringa.h"


#define ODS OutputDebugString

// MultiThreading
bool multi = 1;

void ProcessBasicCompilation(LetThread* lt);

/*
#ifdef _PRG_BASIC_COMPILATION_ // mode 1
Vol3_1.exe, MAVius 2002 - 2003

#ifdef _PRG_INTRENAL_NATIVE_ // mode 2
#ifdef _PRG_EXTERNAL_NATIVE_ // mode 3
#endif
#define _PRG_EXTERNAL_NATIVE_
#define _PRG_INTRENAL_NATIVE_
#define _PRG_BASIC_COMPILATION_
*/

#define _PRG_INTRENAL_NATIVE_
#define _PRG_BASIC_COMPILATION_
//#define _PRG_EXTERNAL_NATIVE_

DWORD ProcessCommandLine(LPTSTR lpCmdLine)
{
	LetString lss(lpCmdLine);
	if (lss.Length() < 2) return 0;
	// lss.AllTrim();
	lss.Trim();
	lss.CutLeft(1);
	bool val = false;
	DWORD state = 0;
	do{
		LetString _off("off");
		if (lss.StrCmpi(_off) == CSTR_EQUAL)
		{
			state = 0;
			val = true;
			break;
		}
		LetString _on("on");
		if (lss.StrCmpi(_on) == CSTR_EQUAL)
		{
			state = 0xFFFFFFFF;
			val = true;
			break;
		}
	} while (false);
	if (val)
	{
		mavLptHW hw;
		hw.Init(12);
		hw.SetValue(state);
		return 1;
	}
	// /off /on /autorun
	return 0;
}

//DWORD BasicProcessor(LetThread*);
BasicProcessorData bp;

DWORD sleepstate = 100;

DWORD run_mode = 1;

void local_main(LetThread* lt)
{
	z_main(lt);
}

void main()
{
	return;
}

void ProcessBasicCompilation(LetThread* lt)
{
	DWORD n;

	//  
	LetFile lf("oulib.mav");
	LetTextStream ls;
	lf._Read = true;
	if (!lf.Open())
	{
		PushError(1, "OuLib.mav file open error - Exit");
		return;
	}
	ls.ConnectStream(lf);

	LetString ss;
	ls.ReadLine(ss); //  

	//    codeline
	bool sig = false;
	DWORD l_size = 0;
	if (!ls.ReadNumber(&l_size, sig))
	{
		PushError(1, "PBC reading codeline size - Exit");
		return;
	}

	DWORD* codeline = new DWORD[l_size * 2];
	ZeroMemory(codeline, l_size * 2);

	for (n = 0; n < l_size; n++)
	{
		if (!ls.ReadNumber(&(codeline[n]), sig))
		{
			PushError(2, "PBC reading reading codeline - Exit");
			return;
		}
	}
	bp.codeline = codeline;
	bp.codesize = l_size;

	ls.ReadLine(ss); // Skip

	DWORD* labelsline = new DWORD[60];
	for (n = 0; n < 50; n ++)
	{
		labelsline[n] = ls.ReadNumber();
	}
	bp.labelsline = labelsline;
	bp.labelssize = 50;

	ls.ReadLine(ss); // Skip

	DWORD* subsline = new DWORD[60];
	for (n = 0; n < 50; n ++)
	{
		subsline[n] = ls.ReadNumber();
	}
	bp.subsline = subsline;
	bp.subssize = 50;

	ls.ReadLine(ss); // Skip

	DWORD* consline = new DWORD[20];
	for (n = 0; n < 10; n ++)
	{
		consline[n] = ls.ReadNumber();
	}
	bp.consline = consline;
	bp.conssize = 50;

	// stack is thin - exit
	//   - 
	// stack is filled - exit
	//   - 

	bp.stack = new DWORD[2];
	bp.stacksize = 2;

	/*	ls.ReadLine(ss);
	StringListA slist;
	slist.LoadFromString(&ss, 1);
	DWORD n;
	for (n = 0; n < l_size; n++)
	{
		LetString* tt = slist.Item(n);
		codeline[n] = tt->GetInteger();
	}*/
	//BREAK();
	/*_ASSERT(false);
	_ASSERT(true);*/
	// 

	lf.Close();
	lf.Close();
	lt->localPointer = &bp;

	// --------------------------------------------------------------
	// Linear (Currend Thread - break)

	
	if (!multi)
	{
		BasicProcessor(lt);
	}
	

	// --------------------------------------------------------------
	// MultiThread

	else
	{
		lt->fun = &BasicProcessor;
		lt->ParentThreadId = GetCurrentThreadId();
		lt->Run();
	}
	

	/*MSG msg;
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		// if (msg.message )
		continue;
	}*/
	// PostThreadMessage(lt->ThreadId, WM_QUIT, 0, 0);
	//BasicProcessor(lt);
	//lt->tryexit = true;
	//Sleep(1000);

	/*{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}*/
}


void z_main(LetThread* lt)
{
//	DWORD n;

	if (run_mode == 1)
		ProcessBasicCompilation(lt);
}

void DoSleep()
{
	Sleep(sleepstate);
}

DWORD BasicProcessor(LetThread* lt)
{

	LocalProcessor* lp = new LocalProcessor;
	lp->Init(0);

#ifdef _PRG_EXTERNAL_NATIVE_
	if (run_mode == 3)
		;
	// Current native compilation
#endif

#ifdef _PRG_INTRENAL_NATIVE_
	if (run_mode == 2)
	{
		// Program - is C++ function
		ExternalProgramEntry(lp, NULL);
		delete lp;

		return 0;
	}
#endif

#ifdef _PRG_BASIC_COMPILATION_
	if (run_mode == 1)
	{
		// Working with Basic compilation ("VOL3_1.exe")
		mavLptHW port;
		port.Init(12);
		port.SetValue(0);
		DWORD speed = 10;
		sleepstate = speed * 10;

		BasicProcessorData* bp = (BasicProcessorData*) lt->localPointer;
		DWORD* lines = bp->codeline;
		DWORD* stack = bp->stack;
		DWORD* subs = bp->subsline;
		DWORD* labels = bp->labelsline;

		LetStack st;


		DWORD zpc = 0; //  
		// DWORD zsp = 10; //  
		DWORD tmp;
		zpc =  bp->labelsline[1];
		DWORD cmd;

		st.Push(1);
		tmp = st.Pop();

		bool wk = true;
		DWORD zeax = 0;
		WORD* ax = (WORD*) &zeax;
		BYTE* al = (BYTE*) &zeax;
		BYTE* ah = (BYTE*) &(((char*) &zeax)[1]); // Collision !!!

		while(wk && (!lt->tryexit))
		{
			tmp = 0;
			cmd = lines[zpc];
			if (cmd > 14) break;
			if (cmd == 0) cmd = 14;
			switch(cmd)
			{
			case 0:
				// Pause
				break;
			case 1:
				// Set
				DoSleep();
				*al = LOBYTE(LOWORD(lines[zpc + 1]));
				*ah = LOBYTE(LOWORD(lines[zpc + 2]));
				zpc += 3;
				break;
			case 2:
				// On
				DoSleep();
				*ax = 0xFFFF;
				zpc += 1;
				break;
			case 3:
				// Off
				DoSleep();
				*ax = 0;
				zpc += 1;
				break;
			case 4:
				// Speed
				speed = lines[zpc + 1];
				sleepstate = speed * 10;
				zpc += 2;
				break;
			case 5:
				// Do
				st.Push(zpc + 2);
				st.Push(lines[zpc + 1]);
				//stack[zsp] = zpc + 2;
				//stack[zsp + 1] = lines[zpc + 1];
				//zsp += 2;
				zpc += 2;
				break;
			case 6:
				// Loop
				(*st.GetPrev(1))--;
				//(stack[zsp - 1])--;
				if ((*st.GetPrev(1)))
				//if (stack[zsp - 1])
				{
					zpc = *st.GetPrev(2);
					//zpc = stack[zsp - 2];
				}
				else
				{
					st.Pop();
					st.Pop();
					// zsp -= 2;
					zpc += 1;
				}
				break;
			case 7:
				// Return
				zpc = st.Pop();
				//zpc = stack[zsp - 1];
				//zsp--;
				break;
			case 8:
				// N/A
				break;
			case 9:
				// Gosub
				st.Push(zpc + 2);
				// stack[zsp] = zpc + 2;
				zpc = subs[lines[zpc + 1]];
				// zsp++;
				break;
			case 10:
				// Goto
				zpc = labels[lines[zpc + 1]];
				break;
			case 11:
				// Complex Randomize
				DoSleep();
				zpc += 5;
				break;
			case 12:
				// Easy Randomize
				DoSleep();
				zpc++;
				break;
			case 13:
				// Nop N
				for (DWORD n = 1; n < lines[zpc + 1]; n++)
					DoSleep();
				zpc += 2;
				break;
			case 14:
				// Pause
				DoSleep();
				zpc++;
				break;
			default:
				break;
			}
			port.SetValue(zeax);
		}

		port.SetValue(0);
		Beep(3000, 200);

		return 0;
	}
#endif
	//PostThreadMessage(lt->ParentThreadId, WM_QUIT, 0, 0);
	return 0;
}


// =============================================================================
// ProcessorFuncParams
// Implementation
ProcessorFuncParams::ProcessorFuncParams()
{
	for (int n = 0; n < 4; n++)
		acommon[n] = new LetStorage();
	acode	= acommon[0];
	alabels	= acommon[1];
	asubs	= acommon[2];
	avars	= acommon[3];
}

ProcessorFuncParams::~ProcessorFuncParams()
{
	for (int n = 0; n < 4; n++)
		ddremove(acommon[n]);
}


void LocalProcessor::GetSleep()
{
	if (ser & 8)
		Sleep(this->base_speed * this->mul_speed);
	return;
}

void LocalProcessor::GetSet()
{
	if (ser & 16)
		SendVal();
	return;
}

void LocalProcessor::SendVal()
{
	Beep(3000, 50);
}

void LocalProcessor::SendVal(DWORD value)
{
	eax = value;
	SendVal();
}

DWORD* LocalProcessor::GetOperand(bool state)
{
	BYTE changer = ser;
	if (state)
		changer >>= 5;
	changer = ser & 7;
	switch(changer)
	{
	case 0:
		return &eax;
	case 1:
		return &ebx;
	case 2:
		return &ecx;
	case 3:
		return &edx;
	case 4:
		second = 0;
		oper1 = &second;
		break;
	case 5:
		second = acode->GetValue(pc++);
		oper1 = &second;
		break;
	case 6:
		{
			signed long sl = (signed long) acode->GetValue(this->pc++);
			if (sl >= 0)	// Global variable (in array)
				oper1 = this->avars->GetPtr(sl);
			else	// Local variable (in stack)
				oper1 = stack->GetPtr(stack->current - sl);
		}
		break;
	case 7:
		second = 0xFFFFFFFF;
		oper1 = &second;
		break;
	default:
		second = 0;
		oper1 = &second;
	}
	return oper1;
}

void LocalProcessor::Zo(void)
{
	DWORD tmp;
	command = acode->GetValue(pc++);

	cmd = LOBYTE(LOWORD(command));
	ser = HIBYTE(LOWORD(command));

	oper = GetOperand(true);
	DWORD second = 0;
	GetSleep();
	switch (cmd)
	{
	case 0:
		// SendVal(*oper);
		// break;
/*
	case 1:
		SendVal(*oper);
		break;
	case 2:
		SendVal(0xFFFFFFFF);
		break;
	case 3:
		SendVal(0);
		break;
	case 4:
		mul_speed = *oper;
		break;
	case 5:
		stack->Push(pc);
		stack->Push(*oper);
		break;
	case 6:
		if (*(stack->GetPrev(0)))
		{
			(*stack->GetPrev(0))--;
			pc = *stack->GetPrev(1);
		}
		else
		{
			stack->Pop();
			stack->Pop();
		}
		break;
	case 7:
		pc = stack->Pop();
		break;
	case 8:
		break;
	case 9:
		stack->Push(pc);
		pc = asubs->GetValue(*oper);
		break;
	case 10:
		pc = *oper;
		break;
	case 11:
		break;
	case 12:
		break;
	case 13:
		break;
	case 14:
		break;
*/
	// === === === Progressive assembler === === ===

	// === Processsing
	case MOV_:
		*oper = *GetOperand(false);
		break;
	case SWAP_:
		tmp = *oper;
		*oper = *GetOperand(false);
		*oper1 = tmp;
		break;
	case AND_:
		*oper &= *GetOperand(false);
		break;
	case OR_:
		*oper |= *GetOperand(false);
		break;
	case XOR_:
		*oper ^= *GetOperand(false);
		break;
	case INV_:
		*oper = ~(*GetOperand(false));
		break;
	case ADD_:
		*oper += *GetOperand(false);
		break;
	case SUB_:
		*oper -= *GetOperand(false);
		break;
	case MUL_:
		*oper *= *GetOperand(false);
		break;
	case DIV_:
		*oper /= *GetOperand(false);
		break;
	case SHL_:
		*oper <<= *GetOperand(false);
		break;
	case SHR_:
		*oper >>= *GetOperand(false);
		break;
	case NOT_:
		*oper = 0 - *GetOperand(false);
		break;
	case INR_:
		*oper++;
		break;
	case DCR_:
		*oper--;
		break;
	case NOP_:
		break;
	case END_:
		_ASSERT(false);
		_ASSERT(true);
		break;

	// === Tests

	case TEST_:
		iffer = (*oper)? true: false;
		break;
	case GT_:
		iffer = (*oper > *GetOperand(false))? true: false;
		break;
	case LT_:
		iffer = (*oper < *GetOperand(false))? true: false;
		break;
	case GTE_:
		iffer = (*oper >= *GetOperand(false))? true: false;
		break;
	case LTE_:
		iffer = (*oper <= *GetOperand(false))? true: false;
		break;
	case EQ_:
		iffer = (*oper == *GetOperand(false))? true: false;
		break;
	case NEQ_:
		iffer = (*oper != *GetOperand(false))? true: false;
		break;

	// === Jumps

	// Labels
	case L_JMP_:
		pc = alabels->GetValue(*oper);
		break;
	case L_JE_:
		if (iffer)
			pc = alabels->GetValue(*oper);
		break;
	case L_JNE_:
		if (!iffer)
			pc = alabels->GetValue(*oper);
		break;
	// Offsets
	case O_JMP_:
		//(*(signed long*) &pc)
			*(signed long*) &pc += *(signed long*) oper;
		break;
	case O_JE_:
		if (iffer)
			*(signed long*) &pc += *(signed long*) oper;
		break;
	case O_JNE_:
		if (!iffer)
			*(signed long*) &pc += *(signed long*) oper;
		break;
	// Abs
	case JMP_:
		pc = *oper;
		break;
	case JE_:
		if (iffer)
			pc = *oper;
		break;
	case JNE_:
		if (!iffer)
			pc = *oper;
		break;

	// === Subprograms

	case PUSH_:
		stack->Push(*oper);
		break;
	case PUSHEX_:
//		stack->Push(*oper);
//		stack->Push(*(DWORD*)&oper); // Indirection need for Push((DWORD) oper)
		break;
	case POP_:
		*oper = stack->Pop();
		break;
	case POPEX_:
//		tmp = stack->Pop();
//		if (tmp)
//			*(DWORD*)tmp = stack->Pop(); // Indirection need for *(DWORD*) tmp = Pop()
		break;
	case CALL_:
		stack->Push(pc + 1);
		pc = this->asubs->GetValue(*oper);
		break;
	case CALLEX_:
//		stack->Push(pc + 1);
//		pc = asubs->GetValue(*oper);
		break;
	case RET_:
		pc = stack->Pop();
		*oper = *GetOperand(false);
		break;
	case RETEX_:
//		pc = stack->Pop();
//		*oper = GetOperand(false);
		break;
/*
	case _:
		break;
*/
	default:
		break;
	}
	GetSet();
}



/*
// Old
0	Pause
1	Set
2	On
3	Off
4	Speed
5	Do
6	Loop
7	Return
8	N/A
9	Gosub
10	Goto
11	Complex Randomize
12	Easy Randomize
13	Nop N
14	Pause

// Progressive
// New
// Registers
Id	Cmd	Placement/Dst, Argument/Src
33	Mov	(GetOperand(true), GetOperand(false))
34	Swap	(GetOperand(true), GetOperand(false))
35	And	(GetOperand(true), GetOperand(false))
36	Or	(GetOperand(true), GetOperand(false))
37	Xor	(GetOperand(true), GetOperand(false))
38	Inv	(GetOperand(true), GetOperand(false))
39	Add	(GetOperand(true), GetOperand(false))
40	Sub	(GetOperand(true), GetOperand(false))
41	Mul	(GetOperand(true), GetOperand(false))
42	Div	(GetOperand(true), GetOperand(false))
43	Shl	ShiftLeft (where GetOperand(true), times GetOperand(false))
44	Shr ShiftRight (where GetOperand(true), times GetOperand(false))
45	Not	(GetOperand(true), GetOperand(false))

// Service

// zoomer remoter
	000	eax
	001	ebx
	010 ecx
	011 edx
	100 0
	101	operand	+pc
	110	variable	+pc
	111 0xFFFFFFFF

// pauser
	0	don't sleep
	1	do sleep

// set
	0	don't set
	1	do set

// complex
	destination, set, pauser, sourcer
	dddsprrr
	s0000, s0001, s0010, s0011, s1000, s1001, s1010, s1011

// summ
	dst, set, pauser, src, command
	rrr  s    p       rrr  cccccccc
	765  4    3       210  76543210


*/

/*
Compiler
=== === === Syntax: === === ===
// Entry
Entry:

// Local Numbered
1:	' Alternate Entry
2:
3:

// Local Named
A:
a:
qwerty:

// Global Named Standard
Entry:
OnStart:
OnExit:

// Sub
Sub 1
Sub a
Sub qwerty

// Global Named
Sub Entry
Sub OnStart
Sub OnExit

Func Abc x=1, y=2, z=3
Func Abc (x=1, y=2, z=3)
Return x

Call Abc ,,7
Call Abc 5,6,7,8
Call Abc (5,,7)
x = Abc (5,6,7)
x = Abc (5, Abc(1) + Abc(2),7)

var x,y,z
gvar x,y,z

101010101010;
000000000000;
0

//

ReadLine()
ReadWord() -> check on sub/label/variable/setting
{
	'='
	ReadWord
	{
		':' label
		'(' sub
		'=' variable
		'' setting
		{
			"01" - dig
			else - variable
		}
	}
}

struct _sub
{
	LS name;
	DWORD Id;
	DWORD tId;
}

*/














//

bool LocalProcessor::Init(DWORD mode)
{
	bytes = 12;
	limiter = hibyte = (1 << bytes);
	limiter--;
	return mavLptHW::Init(12);
}

void LocalProcessor::_sleep()
{
	Sleep(this->abs_speed);
}

void LocalProcessor::_sleep(DWORD ms)
{
	Sleep(ms);
}

void LocalProcessor::_speed(DWORD ms)
{
	this->abs_speed = ms;
}
void LocalProcessor::_set(DWORD dig)
{
	this->eax = dig;
	this->SetValue(dig);
}

void LocalProcessor::_sets(DWORD dig)
{
	_set(dig);
	_sleep();
}

void LocalProcessor::_set()
{
	_set(eax);
}

void LocalProcessor::_sets()
{
	_sets(eax);
}

DWORD LocalProcessor::_get()
{
	return this->GetValue();
}

void LocalProcessor::_inv()
{
	eax = ~eax;
	_set();
}

void LocalProcessor::_shl(DWORD times)
{
	while(times--)
		_shl();
}

void LocalProcessor::_shr(DWORD times)
{
	while(times--)
		_shr();
}

void LocalProcessor::_shl()
{
	eax <<= 1;
	if (eax & hibyte)
		eax |= 1;
	eax &= limiter;
}

void LocalProcessor::_shr()
{
	eax &= limiter;
	if (eax & 1)
		eax |= hibyte;
	eax >>= 1;
}

void LocalProcessor::_set(char* str)
{
	DWORD tmp = 0;
	for (DWORD n = 0; n < 12; n++)
	{
		tmp <<= 1;
		if (str[n] == '1')
			tmp++;
	}
	_set(tmp);
}

void LocalProcessor::_sets(char* str)
{
	_set(str);
	_sleep();
}

void LocalProcessor::_invs()
{
	eax = ~eax;
	_sets();
}

void LocalProcessor::_shls(DWORD times)
{
	while(times--)
	{
		_shl();
		_sets();
	}
}

void LocalProcessor::_shrs(DWORD times)
{
	while(times--)
	{
		_shr();
		_sets();
	}
}

// off
void LocalProcessor::_shls()
{
	_shl();
	_sets();
}

// off
void LocalProcessor::_shrs()
{
	_shr();
	_sets();
}

void LocalProcessor::_clear()
{
	eax = 0;
	_set();
}

void LocalProcessor::_clears()
{
	_clear();
	_sleep();
}
