#include "StdAfx.h"
#include "letthread.h"

char* threadontester = "MAV_LetThread\0\0";
char* threadofftester = "MAV_LetThreadOFF";

LetThread::LetThread(void)
{
	memcpy(this->strid,	threadontester, 16); 
	errorstate = false;
	retval = 0;
	this->fun = 0;
	this->localData = 0;
	this->localId = 0;
	this->localPointer = 0;
	this->ThreadHandle = 0;
	this->ThreadId  = 0;
	this->tryexit = false;
	ParentThreadId = 0;
}

LetThread::~LetThread(void)
{
	memcpy(this->strid,	threadofftester, 16); 
}

// Internal test
bool LetThread::Test()
{
	for (DWORD n = 0; n < 16; n++)
	{
		if (this->strid[n] != threadontester[n])
			return false;
	}
	return true;
}

DWORD LetThread::Run()
{
	// CRTL
	DWORD tId = 0;
	HANDLE tHdl = 0;

#if defined(MS_MANAGED_EXT)
	tHdl = (HANDLE)_beginthreadex(NULL, 0, (apifunc) &ThreadProc, this, 0, (unsigned int*) &tId);
#else
	tHdl = CreateThread(NULL, 0, ThreadProc, this, 0, &this->ThreadId);
#endif
	if (!tHdl) return 1;
	this->ThreadHandle = tHdl;
	this->ThreadId = tId;
	return 0;
	// API
	// this->ThreadHandle = CreateThread(NULL, 0, ThreadProc, this, 0, &this->ThreadId);
}


// Common

DWORD WINAPI ThreadProc(LPVOID lpParameter)
{
	/*DWORD dwTlsIndex = TlsAlloc();
	LPVOID lpvData = (LPVOID) LocalAlloc(LPTR, 256); 
	if (!TlsSetValue(dwTlsIndex, lpvData)) 
		OutputDebugString("TlsSetValue error");
	memcpy(lpvData, "thread_mymymy\0\0\0\0\0\0\0", 16);*/

	LetThread* t = (LetThread*) lpParameter;
	if (!(t->Test()))
	{
		t->retval = 0xFFFFFFFF;
		t->errorstate = true;
		return t->retval;
	}
	if (t->fun)
	{
		t->retval = t->fun(t);
		_endthreadex(t->retval);
		return t->retval;
	}
	else
	{
		t->retval = 0xFFFFFFFF;
		t->errorstate = true;
	}

#if defined(MS_MANAGED_EXT)
		_endthreadex(t->retval);
#else
		ExitThread(t->retval);
#endif
	return t->retval;
}



