// MAVius 2005, LPT Port control
// http://mavius.narod.ru, http://mavius.narod.ru/projects/lpt
// Lpt_port.cpp : Console application.
//   Windows 98, XP

//	       
//	   BIOS:
//
//	[Integrated Peripherals]
//	Onboard Parallel Port = Enabled  0x378h
//	Parallel Port Mode = EPP

#include "stdafx.h"
#include <conio.h>
#include <windows.h>
#include "mavlpthw.h"


/*short LocatePort();
bool TestPort(short addr);
void SendToLPT(short port, short value);
bool DoCommand(int c, short *dig);
*/

int mygetch(HANDLE istr);


// ----------------------------------------------------------------------------
int main(void)
{
	mavLptHW* port = new mavLptHW();
	//  12-   x0, y0, x1, y1, ...
	const char mround[24] =	{ 10, 0, 15, 1, 19, 3, 20, 6, 19, 9, 15, 11,
								10, 12, 5, 11, 1, 9, 0, 6, 1, 3, 5, 1};

	printf(" MAVius 2005, LPT port");

	//   LPT 
	if (!port->Init(12))
		printf("\n No found LPT port!");
	else
		printf("\n Base port: %Xh", port->GetPort());

	printf("\n\n Control Buttons:\n  1,2,3,4,5,6,7,8,9,0,-,=\n");
	printf("  Up, Down, Left, Right Arrows\n  Space, F1, F2, ..., F12, Enter, Esc");

	//     
	HANDLE istr = GetStdHandle(STD_INPUT_HANDLE);
	HANDLE con = GetStdHandle(STD_OUTPUT_HANDLE);

	//     ...
	CONSOLE_CURSOR_INFO cci1, cci2;
	GetConsoleCursorInfo(con, &cci1);
	memcpy(&cci2, &cci1, sizeof(CONSOLE_CURSOR_INFO));
	// ...   .
	cci2.bVisible = FALSE;
	SetConsoleCursorInfo(con, &cci2);
	COORD pos;

	//  -   
	int c = '1';
	// dig      ,
	//     
	DWORD dig = 0;
	while (c != VK_ESCAPE)
	{
		//  ,     dig
		if (port->DoCommand(c, &dig))
		{
			//     dig,     ...
			port->SetValue(dig);

			// ...      .
			//  
			pos.X = 4;
			pos.Y = 9;
			SetConsoleCursorPosition(con, pos);
			for (int n = 0; n < 12; n++)
			{
				if (dig & (1 << n))
					putch('O');
				else
					putch('.');
				putch(' ');
			}

			//  
			for (int n = 0; n < 12; n++)
			{
				pos.X = 40 + mround[n * 2];
				pos.Y = 3 + mround[n * 2 + 1];
				SetConsoleCursorPosition(con, pos);
				if (dig & (1 << n))
					putch('O');
				else
					putch('.');
			}
		}
		c = mygetch(istr);
	}
	pos.X = 1;
	pos.Y = 12;

	//    
	SetConsoleCursorPosition(con, pos);
	SetConsoleCursorInfo(con,&cci1);

	printf("\n Quit...");

	return 0;
}

// ----------------------------------------------------------------------------
//   ,   mygetch()      
//         9x  NT. :)
//   getch() < MS>   .
int mygetch(HANDLE istr)
{
	INPUT_RECORD buf;
	DWORD len;

	//    ,     ,  
	//   
	for(;;)
	{
		ReadConsoleInput(istr, &buf, 1, &len);
		if (buf.EventType == KEY_EVENT)
			if (buf.Event.KeyEvent.bKeyDown)
				return buf.Event.KeyEvent.wVirtualKeyCode;
	}
}
