#pragma once

// Compatibility
#ifndef _MAV_LPT_HW_INTERFACE_
#define _MAV_LPT_HW_INTERFACE_

#include <windows.h>

// =============================================================================
// MAVius - LPT port hardware interface

class mavLptHW
{
private:
	DWORD current_state;
	DWORD base_port;
	DWORD num_leds;

public:
	mavLptHW(void);
	~mavLptHW(void);

	bool Init();
	bool Init(DWORD NumLeds);
	void FreeZ();

	// Informational
	DWORD LocatePort();
	DWORD GetPort();
	bool TestLPTPort(DWORD addr);

	// Work
	void SetValue(DWORD value);
	DWORD GetValue();

	// Compatibility (MAVius 2004, LPT Port console)
	bool DoCommand(int c, DWORD *dig);
};

#endif
