#pragma once

#ifndef _MAV_AUTO_LPT_2005_
#define _MAV_AUTO_LPT_2005_

#include "letfile.h"
#include "lettextstream.h"
#include "stringlista.h"
#include "letthread.h"
#include "mavlpthw.h"

#include "letstorage.h"
#include "letstack.h"

// =============================================================================
// DEFINATIONS

// === Processsing
#define REGISTERS_A	32
// === Tests
#define REGISTERS_B	64
// === Jumps
#define REGISTERS_C	84
// === Subprograms
#define REGISTERS_D	94

// === Processsing
#define	MOV_	(REGISTERS_A + 1)
#define	SWAP_	(REGISTERS_A + 2)
#define	AND_	(REGISTERS_A + 3)
#define	OR_		(REGISTERS_A + 4)
#define	XOR_	(REGISTERS_A + 5)
#define	INV_	(REGISTERS_A + 6)
#define	ADD_	(REGISTERS_A + 7)
#define	SUB_	(REGISTERS_A + 8)
#define	MUL_	(REGISTERS_A + 9)
#define	DIV_	(REGISTERS_A + 10)
#define	SHL_	(REGISTERS_A + 11)
#define	SHR_	(REGISTERS_A + 12)
#define	NOT_	(REGISTERS_A + 13)
// Increment
#define	INR_	(REGISTERS_A + 14)
// Decrement
#define	DCR_	(REGISTERS_A + 15)
#define	NOP_	(REGISTERS_A + 16)
//#define	_	(REGISTERS_A + 17)
#define	END_	(REGISTERS_A + 18)

// === Tests
#define	TEST_	(REGISTERS_B + 1)
#define	GT_	(REGISTERS_B + 2)
#define	LT_	(REGISTERS_B + 3)
#define	GTE_	(REGISTERS_B + 4)
#define	LTE_	(REGISTERS_B + 5)
#define CMP_ EQ_
#define	EQ_	(REGISTERS_B + 6)
#define	NEQ_	(REGISTERS_B + 7)

// === Jumps
// Labels
#define	L_JMP_	(REGISTERS_C + 1)
#define	L_JE_	(REGISTERS_C + 2)
#define	L_JNE_	(REGISTERS_C + 3)
// Offsets
#define	O_JMP_	(REGISTERS_C + 4)
#define	O_JE_	(REGISTERS_C + 5)
#define	O_JNE_	(REGISTERS_C + 6)
// Abs
#define	JMP_	(REGISTERS_C + 7)
#define	JE_	(REGISTERS_C + 8)
#define	JNE_	(REGISTERS_C + 9)

// === Subprograms
#define PUSH_	(REGISTERS_D + 1)
#define PUSHEX_	(REGISTERS_D + 2)
#define	POP_	(REGISTERS_D + 3)
#define	POPEX_	(REGISTERS_D + 4)
#define	CALL_	(REGISTERS_D + 5)
#define	CALLEX_	(REGISTERS_D + 6)
#define	RET_	(REGISTERS_D + 7)
#define	RETEX_	(REGISTERS_D + 8)

// =============================================================================

struct BasicProcessorData
{
	DWORD codesize;
	DWORD* codeline;
	DWORD labelssize;
	DWORD* labelsline;
	DWORD subssize;
	DWORD* subsline;
	DWORD conssize;
	DWORD* consline;
	DWORD* stack;
	DWORD stacksize;
};


void z_main(LetThread* lt);
void local_main(LetThread* lt);
void DoSleep();
DWORD BasicProcessor(LetThread* lt);

// =============================================================================
// ProcessorFuncParams
// Interface
class ProcessorFuncParams
{
public:
	ProcessorFuncParams();
	~ProcessorFuncParams();
	// Program storage
	LetStorage* acode;
	LetStorage* alabels;
	LetStorage* asubs;
	LetStorage* avars;

	// Group of pointers
	LetStorage* acommon[4];
};

// =============================================================================

namespace  ProcessorFuncs
{
	_get_value();
	_sleep();
	_loadnub();
};

class LocalProcessor : public ProcessorFuncParams,
	public mavLptHW
{
	int bytes;
	DWORD hibyte;
	DWORD limiter;
	DWORD command;
	BYTE cmd;
	BYTE ser;
	DWORD* oper;
	DWORD* oper1;
	DWORD second;
	BOOL iffer;

	DWORD eax;
	DWORD ebx;
	DWORD ecx;
	DWORD edx;
	// DWORD stack;
	DWORD sp;
	DWORD pc;
	void Zo(void);
	LetStack* stack;

	// Speed
	DWORD base_speed; // ms
	DWORD mul_speed; // base_speed times
	DWORD abs_speed; // ms

	// Funcs
	DWORD* GetOperand(bool state);
	void GetSleep();
	void GetSet();
	void SendVal();
	void SendVal(DWORD value);

public:
	bool Init(DWORD mode);
	// 0 - Accesser
	// 1 - Compiler
	// 2 - Runer

	// External Funcs
	void _sleep();
	void _sleep(DWORD ms);
	void _speed(DWORD ms);
	void _set(DWORD dig);
	void _sets(DWORD dig);
	void _set();
	void _sets();
	void _set(char* str);
	void _sets(char* str);
	void _shl(DWORD times);
	void _shr(DWORD times);
	void _shl();
	void _shr();
	void _inv();
	void _shls(DWORD times);
	void _shrs(DWORD times);
	void _shls();
	void _shrs();
	void _invs();
	void _clear();
	void _clears();
	DWORD _get();
};

#endif

