#include "StdAfx.h"
#include "letstorage.h"

LetStorage::LetStorage(void)
{
	FreeZ();
}

LetStorage::~LetStorage(void)
{
	FreeZ();
}


void LetStorage::Crop()
{
	if (count)
	{
		if (count < size)
		{
			DWORD* tmp = new DWORD[count];
			size = count;
			memcpy(tmp, data, size * sizeof(DWORD));
			ddremove(data);
			data = tmp;
		}
	}
}

SDWORD LetStorage::Append(DWORD value)
{
	if ((count + 1) >= size)
		Expand();
	data[count] = value;
	return count++;
}

SDWORD LetStorage::Add(DWORD value)
{
	return Append(value);
}

DWORD LetStorage::Remove()
{
	if (count)
		return data[--count];

	return default_value;
}

DWORD LetStorage::GetValue(SDWORD index)
{
	if (index >= count)
		return this->default_value;
	return data[index];
}

DWORD* LetStorage::GetPtr(SDWORD index)
{
	if (index >= count)
		return &this->default_value;
	return &(data[index]);
}

void LetStorage::Expand()
{
	if (size > (count + 8)) return;
	if (size < 64)
		size += 32;
	else
		size *= 2;
	DWORD* tmp = new DWORD[size];
	if (data)
		memcpy(tmp, data, count * sizeof(DWORD));
	ddremove(data);
	data = tmp;
}

void LetStorage::Free()
{
	ddremove(data);
	count = 0;
}

void LetStorage::FreeZ()
{
	data = NULL;
	count = 0;
	size = 0;
	default_value = 0;
}

void LetStorage::SetDefaultValue(DWORD default_value)
{
	this->default_value = default_value;
}

DWORD* LetStorage::GetArray()
{
	if (data);
	else
		Expand();
	return data;

}

DWORD LetStorage::GetCount()
{
	return count;
}
